using RouteConstraint.CustomConstraint;

var builder = WebApplication.CreateBuilder(args);

// Add services to the container.
builder.Services.AddControllersWithViews();

builder.Services.Configure<RouteOptions>(options => options.ConstraintMap.Add("allowedgods", typeof(OnlyGodsConstraint)));

var app = builder.Build();

// Configure the HTTP request pipeline.
if (!app.Environment.IsDevelopment())
{
    app.UseExceptionHandler("/Home/Error");
    // The default HSTS value is 30 days. You may want to change this for production scenarios, see https://aka.ms/aspnetcore-hsts.
    app.UseHsts();
}

app.UseHttpsRedirection();
app.UseStaticFiles();

app.UseRouting();

app.UseAuthorization();

/*app.MapControllerRoute(
    name: "combiningConstraint",
    pattern: "{controller=Home}/{action=Index}/{id:allowedgods}");*/

/*app.MapControllerRoute(
    name: "combiningConstraint",
    pattern: "{controller=Home}/{action=Index}/{id:alpha:regex(^H.*)?}");*/

/*app.MapControllerRoute(
    name: "regexConstraint",
    pattern: "{controller:regex(^H.*)=Home}/{action:regex(^Index$|^About$)=Index}/{id?}");*/

/*app.MapControllerRoute(
    name: "regexConstraint",
    pattern: "{controller:regex(^H.*)=Home}/{action=Index}/{id?}");*/

/*app.MapControllerRoute(
    name: "rangeConstraint",
    pattern: "{controller=Home}/{action=Index}/{id:range(5,20)?}");*/

app.MapControllerRoute(
    name: "intConstraint",
    pattern: "{controller=Home}/{action=Index}/{id:int?}");

app.Run();
